﻿# set site collection owner for all sites...
# 1-2012
Add-PSSnapin Microsoft.SharePoint.PowerShell -ErrorAction SilentlyContinue

# $AccountList is an array of Windows Identities in the format of $AccountList = @("DOMAIN\USERID" , "DOMAIN\USERID2")
$AccountList = @("Lab\tom", "Lab\dick", "lab\harry")

#this gets an array of objects representing the sites at the IIS level:
$IISSites = Get-SPWebApplication
Foreach($oneIISSite in $IISSites)
{
   #using .Sites, we can get a list of the site collections
   foreach ($SharepointSiteCollection in $oneIISSite.Sites)
   {
      write-host $SharepointSiteCollection.url -ForegroundColor Cyan
      $spweb = Get-SPWeb $SharepointSiteCollection.url
      
      #now we have the website, so lets look at each account in our array
      foreach ($Account in $AccountList)
      {
         #lets see if the user already exists
         Write-host "Looking to see if User " $account " is a member on " $SharepointSiteCollection.url -foregroundcolor Blue
         $user = Get-SPUSER -identity $Account -web $SharepointSiteCollection.url -ErrorAction SilentlyContinue #This will throw an error if the user does not exist
         if ($user -eq $null)
         {
            #if the user did NOT exist, then do nothing
           
            Write-host "user $Account not found in URL $($SPWeb.URL)" -Foregroundcolor Magenta
         }
         else
         {
            Write-host "user $Account found in URL $($SPWeb.URL)" -Foregroundcolor DarkGreen
			 if ($user.IsSiteAdmin -eq $true)
			 {
				$user.IsSiteAdmin = $false
				$user.Update()
				Write-host "$account has been removed from the Site collection admin role for $($SPWeb.URL)" -Foregroundcolor Magenta
			 }
			 else
			 { 
			 Write-host "$account is not an admin on $($SPWeb.URL)" -Foregroundcolor DarkGreen
			 }
		 
		 
		 }
		 
     }
     $SharePointSiteCollection.Dispose()
}
}