﻿#this script might be easier to read on this blog if you click the "pop out" icon in the toolbar above.


#first we add the SP snap in so that this can be launched from "normal" powershell
Add-PSSnapin Microsoft.SharePoint.PowerShell –ErrorAction SilentlyContinue

#While not really needed, I like to wrap functionality in a function
function main {

	$path = get-location # gets the location this script is running - it is assumed you have the WSP in the same directory
	$wsp = "TrainingBranding.wsp" #name of the WSP

        #this switch statement lets you assign the webapp URL based on the machine it"s run from - in this way you can use the same script for Dev, stage and production.
	switch($env:computername)
	{
	 "SHAREPOINT2010S" {$webapp = "http://SHAREPOINT2010S"}
	 "StageServerName" {$webapp = "https://stg-url.yoursite.com"}
	 "ProdServerName" {$webapp = "https://prod-url.yorusite.com"}
	 default {write-host "This should be run from the central admin box - Press any key to exit this script"; read-host; exit}
	 }

	
	write-host "Adding solution $path\$wsp to the farm"
	add-spsolution -literalpath "$path\$wsp"
	write-host "Deploying soltuion $wsp to $webapp"
	install-spsolution -Identity $wsp -gacdeployment
	wait4timer($wsp)
	write-host "Done adding" 
	enable-spfeature -identity "370d3250-4961-4c2a-b886-f815c9bf78d1" -url $webapp -confirm:$false
	write-host "Feature enabled, press any key to continue"
	$a = read-host
} #end main

#I grabbed this right from Nik Patel"s script - there are some operations that you cant do in quick succession - the system needs time to copy to each node and let the timer job run it"s course.
# one way to deal with this, is to use a sleep timer, but that"s not exact, I liked Nik"s approach of checking the solution"s job status - well done Nik!
function wait4timer($webapp) {
	$solution = Get-SPSolution | where-object {$_.Name -eq $wsp}
	if ($solution -ne $null) 
	{
		$counter = 1   
		
		Write-Host "Waiting to finish solution timer job"
		while( ($solution.JobExists -eq $true ) -and ( $counter -lt 50 ) ) 
		{   
			Write-Host "Please wait..."
			sleep 2
			$counter++   
		}
		
		Write-Host "Finished the solution timer job" 		
	}
} #end wait4timer
main