﻿#Jack Fruh 2-2013 script to capture storage amounts
Add-PSSnapin Microsoft.SharePoint.PowerShell -ErrorAction SilentlyContinue

$timestamp = get-date -format "yyyyMMdd_hhmmtt"
$date = get-date -format "yyyyMMdd"
$filenameStart = "SizeBySiteCollection"
$outfile = ("C:\Scripts_output\{0}_{1}.csv" -f $filenamestart, $timestamp)

#$WebappList = @("https://url1.com", "https://url2.com")
$WebappList = get-spwebapplication 

$header = "Date,SiteCollectionUrl,Size,DBName"
write-host $header 
$header | out-file $outfile

foreach ($WebApp in $WebAppList){
	$sites = $webapp.sites
	foreach ($site in $sites)
	{
	   $url = $site.url
	   $size = $site.usage.storage
	   $db = $site.contentdatabase.name
	   
	   $line = "$date,$url,$size,$db"
	   write-host $line
	   $line | out-file $outfile -append    
	   Start-Sleep -Milliseconds 100 #give the server a small break between iterations
	}
}